unit ole_word;

interface

Uses
  ole_word_const,
  System.Win.ComObj,
  variants,
  SysUTILS;


//  MS Word
function Word_Open(YesDocAdd:boolean=true; YesVisible:boolean=true): variant;
//  MS Word
function Word_Quit(Var msWord:variant; YesAlertForSave:boolean=false): boolean;
//   MS Word
function Word_Version(msWord:variant): string;
// ()   MS Word
function Word_Doc_Add(msWord:variant) : variant;
//  MS Word  
function Word_Doc_Load(msWord:variant; fn:string): variant;
//   MS Word   (     :  Word_Doc_Load,  Word_Doc_SaveAs  Word_Doc_SaveAs_Ext)
function Word_Doc_Save(vDoc:variant): boolean;
//   MS Word     
function Word_Doc_SaveAs(vDoc:variant; fn:string; YesRewrite:boolean=false): boolean;
//   MS Word      ( )
function Word_Doc_SaveAs_Ext(vDoc:variant; fn:string; FormatDoc:integer=wdFormatDocumentDefault; YesRewrite:boolean=false): boolean;
//   MS Word
function Word_Doc_Print(vDoc:variant): boolean;
//   MS Word
function Word_ActiveDoc_Close(msWord:variant; YesSave: boolean=true): boolean;

implementation


function Word_Open(YesDocAdd:boolean=true; YesVisible:boolean=true): variant;
//  MS Word
//YesDocAdd -  =TRUE,       
//YesVisible -  =TRUE,      MS Word  
//  -   MS Word
begin
  Result:=CreateOleObject('Word.Application');
  if not VarIsEmpty(Result) then begin
     if YesVisible then begin
        Result.Visible:=True;
     end
     else begin
        Result.Visible:=False;
     end;
     if YesDocAdd then begin
        Word_Doc_Add(Result);
     end;
  end;
end;

function Word_Quit(Var msWord:variant; YesAlertForSave:boolean=false): boolean;
//  MS Word
//msWord -   MS Word (. Word_Open)
//YesAlertForSave -  =TRUE (      ),  MS Word     
//  -  
begin
  Result:=false;
  if not VarIsEmpty(msWord) then begin
     TRY
       msWord.Quit(YesAlertForSave);
       Result:=true;
     EXCEPT
     END;
  end;
  msWord:=UnAssigned;
end;

function Word_Version(msWord:variant): string;
//   MS Word
//msWord -   MS Word (. Word_Open)
//  -  MS Word
begin
  Result:='';
  if not VarIsEmpty(msWord) then begin
     Result:=trim(msWord.Version);
  end;
end;

function Word_Doc_Add(msWord:variant) : variant;
// ()   MS Word
//msWord -   MS Word (. Word_Open)
//  -    
begin
  Result:=UnAssigned;
  if not VarIsEmpty(msWord) then begin
     Result:=msWord.Documents.Add;
  end;
end;

function Word_Doc_Load(msWord:variant; fn:string): variant;
//  MS Word  
//msWord -   MS Word (. Word_Open)
//fn -    
//  -    
begin
  Result:=UnAssigned;
  if not VarIsEmpty(msWord) then begin
     fn:=trim(fn);
     if length(fn)>0 then begin
        if FileExists(fn) then begin
           Result:=msWord.Documents.Open(fn);
        end;
     end;
  end;
end;

function Word_Doc_Save(vDoc:variant): boolean;
//   MS Word   (     :  Word_Doc_Load,  Word_Doc_SaveAs  Word_Doc_SaveAs_Ext)
//vDoc -    MS Word (. Word_Doc_Add, Word_Doc_Load)
//  -  
begin
  Result:=false;
  if not VarIsEmpty(vDoc) then begin
     vDoc.Save;
     Result:=true;
  end;
end;

function Word_Doc_SaveAs(vDoc:variant; fn:string; YesRewrite:boolean=false): boolean;
//   MS Word     
//vDoc -    MS Word (. Word_Doc_Add, Word_Doc_Load)
//fn -     
//YesRewrite -  =TRUE     fn  ,   ""
//  -  
Var
  Yes:boolean;
begin
  Result:=false;
  fn:=trim(fn);
  if length(fn)>0 then begin
     Yes:=true;
     if not YesRewrite then begin
        if FileExists(fn) then Yes:=false;
     end;
     if Yes then begin
        if not VarIsEmpty(vDoc) then begin
           vDoc.SaveAs(fn);
           Result:=true;
        end;
     end;
  end;
end;

function Word_Doc_SaveAs_Ext(vDoc:variant; fn:string; FormatDoc:integer=wdFormatDocumentDefault; YesRewrite:boolean=false): boolean;
//   MS Word      ( )
//vDoc -    MS Word (. Word_Doc_Add, Word_Doc_Load)
//fn -     
//FormatDoc -   (.   wdFormat* )
//YesRewrite -  =TRUE     fn  ,   ""
//  -  
Var
  Yes:boolean;
begin
  Result:=false;
  fn:=trim(fn);
  if length(fn)>0 then begin
     Yes:=true;
     if not YesRewrite then begin
        if FileExists(fn) then Yes:=false;
     end;
     if Yes then begin
        if not VarIsEmpty(vDoc) then begin
           vDoc.SaveAs(fn, FileFormat:=FormatDoc);
           Result:=true;
        end;
     end;
  end;
end;

function Word_Doc_Print(vDoc:variant): boolean;
//   MS Word
//vDoc -    MS Word (. Word_Doc_Add, Word_Doc_Load)
//  -  
begin
  Result:=false;
  if not VarIsEmpty(vDoc) then begin
     vDoc.PrintOut;
     Result:=true;
  end;
end;

function Word_ActiveDoc_Close(msWord:variant; YesSave: boolean=true): boolean;
//   MS Word
//msWord -   MS Word (. Word_Open)
//YesSave -  =TRUE (      ),  MS Word    (    )     
//  -  
begin
  Result:=false;
  if not VarIsEmpty(msWord) then begin
     if not VarIsEmpty(msWord.ActiveDocument) then begin
        if YesSave then begin
           msWord.ActiveDocument.Close;
        end
        else begin
           msWord.ActiveDocument.Close(SaveChanges:=0);
        end;
        Result:=true;
     end;
  end;
end;


end.
