unit ole_word_const;

interface


Const
  MsWord_NonBreakingSpaceCode = 160;   //ascii-  "   MS Word"
  MsWord_NonBreakingSpaceChar = #160;  // "   MS Word"


Const

//..............................................
//https://docs.microsoft.com/en-us/office/vba/api/word.wdsaveformat
//  . WdSaveFormat Enumeration (Word)
  wdFormatDocument = 0; //Microsoft Office Word 97 - 2003 binary file format.
  wdFormatDOSText  = 4; //Microsoft DOS text format.
  wdFormatDOSTextLineBreaks = 5; //Microsoft DOS text with line breaks preserved.
  wdFormatEncodedText = 7; //Encoded text format.
  wdFormatFilteredHTML = 10; //Filtered HTML format.
  wdFormatFlatXML = 19; //Open XML file format saved as a single XML file.
  wdFormatFlatXML2 = 20; //Open XML file format with macros enabled saved as a single XML file.
  wdFormatFlatXMLTemplate = 21; //Open XML template format saved as a XML single file.
  wdFormatFlatXMLTemplateMacroEnabled = 22; //Open XML template format with macros enabled saved as a single XML file.
  wdFormatOpenDocumentText = 23; //OpenDocument Text format.
  wdFormatHTML = 8; //Standard HTML format.
  wdFormatRTF = 6; //Rich text format (RTF).
  wdFormatStrictOpenXMLDocument = 24; //Strict Open XML document format.
  wdFormatTemplate = 1; //Word template format.
  wdFormatText = 2; //Microsoft Windows text format.
  wdFormatTextLineBreaks = 3; //Windows text format with line breaks preserved.
  wdFormatUnicodeText = 7; //Unicode text format.
  wdFormatWebArchive = 9; //Web archive format.
  wdFormatXML = 11; //Extensible Markup Language (XML) format.
  wdFormatDocument97 = 0; //Microsoft Word 97 document format.
  wdFormatDocumentDefault = 16; //Word default document file format. For Word, this is the DOCX format.
  wdFormatPDF = 17; //PDF format.
  wdFormatTemplate97 = 1; //Word 97 template format.
  wdFormatXMLDocument = 12; //XML document format.
  wdFormatXMLDocumentMacroEnabled = 13; //XML document format with macros enabled.
  wdFormatXMLTemplate = 14; //XML template format.
  wdFormatXMLTemplateMacroEnabled = 15; //XML template format with macros enabled.
  wdFormatXPS = 18; //XPS format.
//..............................................

Const

//..............................................
//https://docs.microsoft.com/en-us/office/vba/api/word.wdsaveoptions
//WdSaveOptions Enumeration (Word)
  wdDoNotSaveChanges = 0; //Do not save pending changes.
  wdPromptToSaveChanges = -2; //Prompt the user to save pending changes.
  wdSaveChanges = -1; //Save pending changes automatically without prompting the user.
//..............................................


  //..............................................
  // Selection.Move
  WdCharacter =1;  //   
  WdWord=2;        //   
  WdSentence=3;    //   
  WdParagraph=4;   //   
  WdSection=8;     //   
  WdStory=6;       //     
  WdCell=12;       //   
  WdColumn=9;      //   
  WdRow=10;        //   
  WdTable=15;      //   
  WdLine=5;        //   
  //..............................................

Const

  //..............................................
  //https://docs.microsoft.com/en-us/office/vba/api/word.wdcontentcontroltype
  //WdContentControlType enumeration (Word)
  wdContentControlBuildingBlockGallery = 5; //Specifies a building block gallery content control.
  wdContentControlCheckbox = 8; //Specifies a checkbox content control.
  wdContentControlComboBox = 3; //Specifies a combo box content control.
  wdContentControlDate = 6; //Specifies a date content control.
  wdContentControlGroup = 7; //Specifies a group content control.
  wdContentControlDropdownList = 4; //Specifies a drop-down list content control.
  wdContentControlPicture = 2; //Specifies a picture content control.
  wdContentControlRepeatingSection = 9; //Specifies a repeating section content control.
  wdContentControlRichText = 0; //Specifies a rich-text content control.
  wdContentControlText = 1; //Specifies a text content control
  //..............................................


//..............................................
// 
Const

  word_char_code_is_SLF = 11; // : "  "

//..............................................

Const

  //..............................................
  //VB.  
  vbext_ct_StdModule       = 1;
  vbext_ct_ClassModule     = 2;
  vbext_ct_Document        = 100;
  vbext_ct_MSForm          = 3;
  vbext_ct_ActiveXDesigner = 11;
  //..............................................


const

  wdSeekMainDocument = $00000000;
  wdSeekPrimaryHeader = $00000001;
  wdSeekFirstPageHeader = $00000002;
  wdSeekEvenPagesHeader = $00000003;
  wdSeekPrimaryFooter = $00000004;
  wdSeekFirstPageFooter = $00000005;
  wdSeekEvenPagesFooter = $00000006;
  wdSeekFootnotes = $00000007;
  wdSeekEndnotes = $00000008;
  wdSeekCurrentPageHeader = $00000009;
  wdSeekCurrentPageFooter = $0000000A;

const

   wdFirstCharacterLineNumber = 10;

   wdGoToBookmark = -1;
   wdGoToSection = 0;
   wdGoToPage = 1;
   wdGoToTable = 2;
   wdGoToLine = 3;
   wdGoToFootnote = 4;
   wdGoToEndnote = 5;
   wdGoToComment = 6;
   wdGoToField = 7;
   wdGoToGraphic = 8;
   wdGoToObject = 9;
   wdGoToEquation = 10;
   wdGoToHeading = 11;
   wdGoToPercent = 12;
   wdGoToSpellingError = 13;
   wdGoToGrammaticalError = 14;
   wdGoToProofreadingError = 15;
   wdGoToFirst = 1;
   wdGoToLast = -1;
   wdGoToNext = 2;   //,
   wdGoToRelative = 2;  //    ?
   wdGoToPrevious = 3;
   wdGoToAbsolute = 1;

   wdAlignParagraphLeft = $00000000;
   wdAlignParagraphCenter = $00000001;
   wdAlignParagraphRight = $00000002;
   wdAlignParagraphJustify = $00000003;
   wdAlignParagraphDistribute = $00000004;
   wdAlignParagraphJustifyMed = $00000005;
   wdAlignParagraphJustifyHi = $00000007;
   wdAlignParagraphJustifyLow = $00000008;

  wdWord9TableBehavior = 1;
  wdAutoFitFixed = 0;
  wdAutoFitContent = 1;
  wdAutoFitWindow = 2;

  //
  wdLineStyleNone = 0;
  wdLineStyleSingle = 1;
  wdLineStyleDot = 2;
  wdLineStyleDashSmallGap = 3;
  wdLineStyleDashLargeGap = 4;
  wdLineStyleDashDot = 5;
  wdLineStyleDashDotDot = 6;
  wdLineStyleDouble = 7;
  wdLineStyleTriple = 8;
  wdLineStyleThinThickSmallGap = 9;
  wdLineStyleThickThinSmallGap = 10;
  wdLineStyleThinThickThinSmallGap = 11;
  wdLineStyleThinThickMedGap = 12;
  wdLineStyleThickThinMedGap = 13;
  wdLineStyleThinThickThinMedGap = 14;
  wdLineStyleThinThickLargeGap = 15;
  wdLineStyleThickThinLargeGap = 16;
  wdLineStyleThinThickThinLargeGap = 17;
  wdLineStyleSingleWavy = 18;
  wdLineStyleDoubleWavy = 19;
  wdLineStyleDashDotStroked = 20;
  wdLineStyleEmboss3D = 21;
  wdLineStyleEngrave3D = 22;
  wdLineStyleOutset = 23;
  wdLineStyleInset = 24;

  // InsertBreak
  wdTextWrappingBreak = 11; //       ,    .      ,    ,      .
  wdLineBreakClearRight = 10; //   .
  wdLineBreakClearLeft = 9; //   .
  wdColumnBreak = 8; // .
  wdPageBreak = 7; //  .
  wdLineBreak = 6; //   .
  wdSectionBreakOddPage = 5; //      .
  wdSectionBreakEvenPage = 4; //      .
  wdSectionBreakContinuous = 3; //    .
  wdSectionBreakNextPage = 2; //     .



  //https://club.directum.ru/post/778
  // 
  wdPreferredWidthPoints = 3;     //
  wdPreferredWidthPercent = 2;    //
  // 
  wdCellAlignVerticalTop = 0; //  
  wdCellAlignVerticalCenter = 1; // 
  wdCellAlignVerticalBottom = 2; //  


Const
  wdFindAsk = 2; //       , Microsoft Word    ,        .
  wdFindContinue = 1; //  -           .
  wdFindStop = 0; //  ,       .
  wdReplaceOne = 1;
  wdReplaceAll = 2;


Const
  //-------------------------
  //WdFontBias Enum
  //https://docs.microsoft.com/ru-ru/dotnet/api/microsoft.office.interop.word.wdfontbias?view=word-pia
  wdFontBiasDefault  = 0;   //   .
  wdFontBiasDontCare = 255; //   .
  wdFontBiasFareast  = 1;   //   .
  //-------------------------

implementation




end.
